<template>
  <div class="border-none px-0">
    <label
      v-if="label != null"
      :for="id"
      class="text-yellow-600 font-bold text-lg"
      >{{ label }}</label
    >
    <component
      :is="component"
      :id="id"
      :name="name"
      :value.prop="$attrs.value !== undefined ? $attrs.value : values[name]"
      :checked="
        checked !== null
          ? checked
          : $attrs.value && $attrs.value === values[name]
      "
      v-bind="$attrs"
      :class="propClass"
      @input="
        $emit('input', $event);
        values[name] =
          $attrs.type === 'checkbox'
            ? $event.target.checked
            : $event.target.value;
      "
      v-on="$listeners"
    >
      <span
        v-if="icon != null"
        class="absolute left-0 inset-y-0 flex items-center pl-3"
      >
        <font-awesome-icon
          :icon="icon"
          :class="`h-5 w-5 text-${color}-400 group-hover:text-${color}-300`"
        />
      </span>
      <slot>{{ component === "textarea" ? values[name] : "" }}</slot>
    </component>
    <ul class="errors">
      <li
        v-for="(error, index) in violations[name]"
        :key="index"
        class="text-red-600"
      >
        {{ error }}
      </li>
    </ul>
  </div>
</template>

<script>
export default {
  name: "Field",
  inject: ["values", "violations"],
  props: {
    component: String,
    name: {
      type: String,
      default: null,
    },
    label: {
      default: null,
      Type: String,
    },
    color: {
      default: "yellow",
      type: String,
    },
    icon: {
      default: null,
      svg: String,
    },
    checked: {
      default: null,
      type: Boolean,
    },
    id: String,
    propClass: {
      type: String,
      default() {
        return ["button", "submit"].includes(this.$attrs.type)
          ? `group relative w-full flex justify-center py-3 px-4 border border-transparent text-sm font-medium rounded-md text-white bg-${this.color}-500 hover:bg-${this.color}-600 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-${this.color}-400`
          : ["radio"].includes(this.$attrs.type)
          ? "appearance-none focus:ring-yellow-500 focus:border-yellow-500 text-yellow-500"
          : "appearance-none rounded-lg w-full py-3 border border-gray-300 placeholder-gray-300 text-gray-900 focus:outline-none focus:ring-yellow-500 focus:border-yellow-500 focus:z-10 sm:text-sm";
      },
    },
  },
};
</script>

<style scoped></style>
